# -*- coding: utf8 -*- 

import sys
from flickrapi import FlickrAPI

APIKEY = open("/home/tanique/.flickr/api_key.txt").read().strip()
SECRET = open("/home/tanique/.flickr/sharedsecret.txt").read().strip()

def lleva(img, title, descrip, verbose=False):
    # levantamos toda la info de auth
    fapi = FlickrAPI(APIKEY, SECRET)

#   Tenemos que pasarle el browser si es la primera vez
#   Se lo podemos pasar siempre, pero como esto lo ejecuto remoto,
#   prefiero no ponerlo...
#    token = fapi.getToken(perms="write", browser="firefox")
    token = fapi.getToken(perms="write")
    if verbose: print "Auth info OK"
    
    # leemos la imagen y la subimos
    rsp = fapi.upload(jpegData=img, api_key=APIKEY, auth_token=token,
            title=title, description=descrip, tags="blog",
            is_friend="0", is_public="1", is_family="0")
    fapi.testFailure(rsp)
    pid = rsp.photoid[0].elementText
    if verbose: print "Ok subiendo, photoid: id: %s" % pid

    rsp = fapi.photos_getSizes(api_key=APIKEY, photo_id=pid)
    sizes = rsp.sizes[0].size
    for siz in sizes:
        if siz.attrib["label"] in ("Large", "Original"):
            imgurl = siz.attrib["source"]
            break
    else:
        print "Error al parsear la respuesta del getSizes!:", rsp.xml
        sys.exit()
    if verbose: print "URL: %r" % imgurl

    return imgurl


if __name__ == "__main__":
    if len(sys.argv) != 2:
        print "Usar: subeFlickr.py <arch>"
        sys.exit()

    img = open(sys.argv[1]).read()
    lleva(img, "Ejemplo", "Foto subida para demo", True)
